local stack = debugstack(1, 1, 0)
local folder = stack:match("[Oo%.][Nn%.][Ss%.]\\([^\\]+)\\")
if not folder then return end

local function addArtwork(type,name,relativePath)
	local kgPanels = LibStub("AceAddon-3.0"):GetAddon("kgPanels")
	if kgPanels.AddAsset then
		kgPanels:AddAsset(type,name, "Interface\\Addons\\"..folder.."\\"..relativePath)
	else
		error("kgPanels installed is not compatible. Please get Version 1.27 or greater.")
	end
end

-- Sample background and border calls
addArtwork("background","My Background","eyeball.tga")
addArtwork("border","My Border","eyeball.tga")
addArtwork("background","BattleForAzerothUiArtByHax1","BattleForAzerothUiArtByHax1.tga")
addArtwork("background","BattleForAzerothUiArtByHax2","BattleForAzerothUiArtByHax2.tga")
addArtwork("background","BattleForAzerothUiArtByHax3","BattleForAzerothUiArtByHax3.tga")
addArtwork("background","BattleForAzerothUiArtByHax4","BattleForAzerothUiArtByHax4.tga")
addArtwork("background","BattleForAzerothUiArtByHaxMap","BattleForAzerothUiArtByHaxMap.tga")
addArtwork("background","BattleForAzerothUiArtByHaxPlayerFrame","BattleForAzerothUiArtByHaxPlayerFrame.tga")
addArtwork("background","BattleForAzerothUiArtByHaxTargetFrame","BattleForAzerothUiArtByHaxTargetFrame.tga")

-- We only need to run once, so lets disable ourselves
DisableAddOn(folder)
